// VECTSUB           Vector Subtraction

// This program will subtract two three-element vectors V
// and W, storing the three-element vector result at R.
        .data                     // Declare storage
        .align  8                 // Desirable alignment
V:      data8   -1,+3,+5          // Vx, Vy, Vz
W:      data8   -2,-4,+6          // Wx, Wy, Wz
R:      .skip   3*8               // Space for Rx, Ry, Rz
         .text                    // Section for code
        .align  32                // Desirable alignment
        .globl  main#             // These three lines
        .proc   main#             //  mark the mandatory
main:                             //   'main' program entry
                                  // Now we really begin...
first:  movl    r14 = V;;         // Pointer for V
        movl    r15 = W;;         // Pointer for W
        movl    r16 = R;;         // Pointer for R
        ld8     r20 = [r14],8;;   // Get Vx; bump pointer
        ld8     r21 = [r15],8;;   // Get Wx; bump pointer
        sub     r20 = r20,r21;;   // Compute Rx
        st8     [r16] = r20,8;;   // Put Rx; bump pointer
        ld8     r20 = [r14],8;;   // Get Vy; bump pointer
        ld8     r21 = [r15],8;;   // Get Wy; bump pointer
        sub     r20 = r20,r21;;   // Compute Ry
        st8     [r16] = r20,8;;   // Put Ry; bump pointer
        ld8     r20 = [r14],8;;   // Get Vz; bump pointer
        ld8     r21 = [r15],8;;   // Get Wz; bump pointer
        sub     r20 = r20,r21;;   // Compute Rz
        st8     [r16] = r20,8;;   // Put Rz; bump pointer
                                  // No more components...
done:   mov     r8 = r0;;         // Signal all is normal
        br.ret.sptk.many b0       // Back to command line
        .endp   main#             // Mark end of procedure
